Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1058955 - addr2line gives inconsistent output (fixed upstream)
Summary: addr2line gives inconsistent output (fixed upstream)
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: binutils
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Nick Clifton
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-01-28 20:18 UTC by Andy Lutomirski
Modified: 2015-06-29 14:50 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-29 14:50:18 UTC


Attachments (Terms of Use)

Description Andy Lutomirski 2014-01-28 20:18:35 UTC
This is a terrible bug report -- sorry.

Using Fedora 20's binutils, I get:

$ cat addrs.txt
000000000027bf0d
0000000000564ed8
000000000027dac4
0000000000564ed8

$ addr2line -a -e badsofile.so  <addrs.txt
0x000000000027bf0d
[redacted file 1]:39
0x0000000000564ed8
??:?
0x000000000027dac4
[redacted file 2]:53
0x0000000000564ed8
/usr/include/c++/4.8.2/bits/stl_tree.h:401

Note that this is obvious garbage -- 564ed8 is resolving to two different things.

Using binutils trunk, I get:

$ ~/apps/binutils-trunk/bin/addr2line -a -e badsofile.so  <addrs.txt
0x000000000027bf0d
[redacted file 1]:39
0x0000000000564ed8
??:?
0x000000000027dac4
[redacted file 2]:53
0x0000000000564ed8
??:?

If this rings a bell and you can point me at a commit to look at, I can try test.  Otherwise I can try to generate a .so file that I can actually distribute that has this issue or I can try to bisect.

This bug is annoying because it causes pprof to be almost completely useless -- pprof relies on addr2line on the address on '_fini' to generate consistent results.

Comment 1 Nick Clifton 2014-01-29 08:56:22 UTC
Hi Andy,

  This bug looks like the one reported here:

https://sourceware.org/bugzilla/show_bug.cgi?id=15994

  Perhaps the patch there can help you ?

Cheers
  Nick

Comment 2 Andy Lutomirski 2014-01-29 18:30:42 UTC
I'll test that patch.

This sounds like a bug in ld or gcc -- there's nothing particularly special going on to generate that .so file.  Do you think it's worth trying to track down why bogus data like this is being generated?

I don't know any efficient way to find the bogus data or to check a .so file to see if it has this problem.

Comment 3 Andy Lutomirski 2014-10-10 23:01:14 UTC
Sorry for the huge delay.

I'm confused.  I can easily reproduce this issue with Fedora 20's binutils, but I can't reproduce it with binutils 2.23's branch, which does not appear to have the fix.

Comment 4 Fedora End Of Life 2015-05-29 10:43:18 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 5 Fedora End Of Life 2015-06-29 14:50:18 UTC
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.